<template>
  <lull-modal :modelValue="modelValue">
    <template v-slot:header>
      <div class="text-2xl font-bold">Confirm</div>
    </template>

    <template v-slot:body>
      <div class="pb-5 text-base">
        {{ message }}
      </div>
    </template>

    <template v-slot:actions>
      <lull-button type="danger" class="mr-3" @click="cancel()">
        Cancel
      </lull-button>
      <lull-button type="info" @click="confirm()">Confirm</lull-button>
    </template>
  </lull-modal>
</template>

<script lang="ts">
import { defineComponent } from 'vue';

export default defineComponent({
  name: 'confirm',
  emits: ['update:modelValue'],
  props: {
    modelValue: { type: Boolean, required: false, default: false },
    message: { type: String, required: false, default: 'Are you sure?' },
    callback: { type: Function, required: false },
  },
  setup(props, { emit }) {
    async function confirm(): Promise<void> {
      if (props.callback) {
        await props.callback();
      }

      emit('update:modelValue', false);
    }

    function cancel(): void {
      emit('update:modelValue', false);
    }

    return { confirm, cancel };
  },
});
</script>